use std::fs;

use config::Config;
use welcome_msg::print_startup_msg;

mod config;

#[allow(unused)]
mod error_reporting;
mod welcome_msg;

fn main() {
    // TODO: proper error handling across the whole function
    //       don't forget to also look inside `Config`
    let cfg = Config::read();

    if cfg.startup_msg {
        print_startup_msg();
    }

    let source = fs::read_to_string(cfg.source).expect("can't find source file");
    let ir = ir::from_ron(&source).expect("failed to parse source to graph ir");

    let mut machine = cfg.evaluator.pick();
    machine.feed(ir);
    machine.eval_full();
}
